@echo off

:: --------------------------------------------
:: TIF-Clean Installer/Uninstaller (NT version)
:: --------------------------------------------
::
:: Created by Eric L. Howes
::            eburger68@myrealbox.com
::            http://www.staff.uiuc.edu/~ehowes/
::
:: This file installs and uninstalls the Windows NT/2K/XP version of 
:: TIF-Clean (TIF-CLN-NT). This version can also be used on Windows 9x/Me
:: systems, if desired.
::
:: Copyright (c) 2000-2003 Eric L. Howes
::
:: This program is free software; you can redistribute it and/or modify it under
:: the terms of the GNU General Public License as published by the Free Software
:: Foundation; either version 2, or (at your option) any later version.
::
:: This program is distributed in the hope that it will be useful, but WITHOUT ANY
:: WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
:: A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
::
:: Some files distributed with this package may not be covered by the GNU GPL. Those
:: files remain the property of their original owners and are covered by the licenses
:: under which they were originally distributed.
::
:: All trademarks are the property of their respective owners.
::
:: You should have received a copy of the GNU General Public License along with this
:: program; see the file COPYING.  If not, write to the Free Software Foundation,
:: 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

::********************************************************************
::CHOICE Installation
::********************************************************************

:: Check for NT or 9x
if exist %WINDIR%\SYSTEM32\CONFIG goto prep-nt

:: ---------------
:: Copy choice.com
:: ---------------
:prep-9x

if exist %WINDIR%\command\choice.com goto MENU
if exist %WINDIR%\choice.com goto MENU

copy choice\choice.com %WINDIR%

goto MENU

:: ---------------
:: Copy choice.exe
:: ---------------
:prep-nt

if exist %WINDIR%\command\choice.exe goto MENU
if exist %WINDIR%\choice.exe goto MENU

copy choice\choice.exe %WINDIR%

goto MENU

::********************************************************************
:MENU
::********************************************************************

cls

echo.
echo    -------------------------------
echo    TIF-Clean Installer\Uninstaller
echo    -------------------------------
echo.
echo    [1] Install TIF-Clean
echo.
echo    [2] Uninstall TIF-Clean
echo.
echo    [3] Exit
echo.
echo    Which do you wish to do?
echo.

choice /c:1234 /n /t:4,90 Please Choose One...

if errorlevel 4 goto menu
if errorlevel 3 goto end
if errorlevel 2 goto uninst
if errorlevel 1 goto install

goto menu

::********************************************************************
:install
::********************************************************************

cls

echo    -----------------
echo    Install TIF-Clean
echo    -----------------
echo.
echo    [1] Install DELTREE Version
echo.
echo    [2] Install WIPE Version
echo.
echo    [3] Return to Main Menu
echo.
echo    [4] Exit
echo.
echo    Which do you wish to do?
echo.

choice /c:12345 /n /t:5,90 Please Choose One...

if errorlevel 5 goto install
if errorlevel 4 goto end
if errorlevel 3 goto menu
if errorlevel 2 goto wip-inst
if errorlevel 1 goto dt-inst

::~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
:dt-inst
::~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

cls

:: ** Install TIF-Clean DELTREE Version **

:: check for existence of key files

if not exist 9x\tif-cln.reg goto error
if not exist 9x\re-tif.reg goto error
if not exist 9x\re-tif.bat goto error
if not exist nt4\tif-cln.reg goto error
if not exist nt4\re-tif.reg goto error
if not exist nt4\re-tif.bat goto error
if not exist 2k\tif-cln.reg goto error
if not exist 2k\re-tif.reg goto error
if not exist 2k\re-tif.bat goto error
if not exist xp\tif-cln.reg goto error
if not exist xp\re-tif.reg goto error
if not exist xp\re-tif.bat goto error

:: clear pre-existing files from Windows directory

if exist %WINDIR%\tif-cln.bat del %WINDIR%\tif-cln.bat
if exist %WINDIR%\tif-cln.pif del %WINDIR%\tif-cln.pif
if exist %WINDIR%\tif-cln.reg del %WINDIR%\tif-cln.reg
if exist %WINDIR%\re-tif.bat del %WINDIR%\re-tif.bat
if exist %WINDIR%\re-tif.pif del %WINDIR%\re-tif.pif

:: detect Windows version and jump to right section

if exist %WINDIR%\system\vmm32.vxd goto dt-9xme
if exist %SYSTEMROOT%\System32\Dllcache goto dt-2kxp

:dt-nt4

:: check for key file and install NT4 version

if not exist NT4\tif-del.bat goto error

copy NT4\tif-del.bat %WINDIR%\tif-cln.bat
copy NT4\tif-cln.reg %WINDIR%\tif-cln.reg
copy NT4\re-tif.bat %WINDIR%\re-tif.bat

goto reg-inst2

:dt-2kxp

:: check for key file and install 2K-XP version

if not exist 2K\tif-del.bat goto error
if not exist XP\tif-del.bat goto error

cls

echo    -------------------
echo    Windows 2000 or XP?
echo    -------------------
echo.
echo    [1] Install for Windows 2000
echo.
echo    [2] Install for Windows XP
echo.
echo    [3] Return to Main Menu
echo.
echo    [4] Exit
echo.
echo    Which do you wish to do?
echo.

choice /c:12345 /n /t:5,90 Please Choose One...

if errorlevel 5 goto dt-2kxp
if errorlevel 4 goto end
if errorlevel 3 goto menu
if errorlevel 2 goto dt-xp
if errorlevel 1 goto dt-2000

:dt-2000

copy 2K\tif-del.bat %WINDIR%\tif-cln.bat
copy 2K\tif-cln.reg %WINDIR%\tif-cln.reg
copy 2K\re-tif.bat %WINDIR%\re-tif.bat

goto reg-inst2

:dt-xp

copy XP\tif-del.bat %WINDIR%\tif-cln.bat
copy XP\tif-cln.reg %WINDIR%\tif-cln.reg
copy XP\re-tif.bat %WINDIR%\re-tif.bat

goto reg-inst1

:dt-9xme

:: check for key file and install 9X version

if not exist 9X\tif-del.bat goto error

copy 9X\tif-del.bat %WINDIR%\tif-cln.bat
copy 9X\tif-cln.reg %WINDIR%\tif-cln.reg
copy 9X\re-tif.bat %WINDIR%\re-tif.bat

goto reg-inst1

:reg-inst1

:: install prelim Registry entries for 9X and XP

start /w regedit.exe /s 9X\re-tif.reg
start /w regedit.exe /s 9X\tif-cln.reg

if exist %WINDIR%\command\deltree.exe goto success
if exist %WINDIR%\deltree.exe goto success

copy deltree.exe %WINDIR%

goto success

:reg-inst2

:: install prelim Registry entries for NT and 2K

start /w regedit.exe /s NT4\re-tif.reg
start /w regedit.exe /s NT4\tif-cln.reg

if exist %WINDIR%\command\deltree.exe goto success
if exist %WINDIR%\deltree.exe goto success

copy deltree.exe %WINDIR%

goto success

::~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
:wip-inst
::~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

cls

:: ** Install TIF-Clean WIPE Version **

:: check for existence of key files

if not exist 9x\tif-cln.reg goto error
if not exist 9x\re-tif.reg goto error
if not exist 9x\re-tif.bat goto error
if not exist nt4\tif-cln.reg goto error
if not exist nt4\re-tif.reg goto error
if not exist nt4\re-tif.bat goto error
if not exist 2k\tif-cln.reg goto error
if not exist 2k\re-tif.reg goto error
if not exist 2k\re-tif.bat goto error
if not exist xp\tif-cln.reg goto error
if not exist xp\re-tif.reg goto error
if not exist xp\re-tif.bat goto error

:: clear pre-existing files from Windows directory

if exist %WINDIR%\tif-cln.bat del %WINDIR%\tif-cln.bat
if exist %WINDIR%\tif-cln.pif del %WINDIR%\tif-cln.pif
if exist %WINDIR%\tif-cln.reg del %WINDIR%\tif-cln.reg
if exist %WINDIR%\re-tif.bat del %WINDIR%\re-tif.bat
if exist %WINDIR%\re-tif.pif del %WINDIR%\re-tif.pif

:: detect Windows version and jump to right section

if exist %WINDIR%\system\vmm32.vxd goto wip-9xme
if exist %SYSTEMROOT%\System32\Dllcache goto wip-2kxp

:wip-nt4

:: check for key file and install NT4 version

if not exist NT4\tif-wip.bat goto error

copy NT4\tif-wip.bat %WINDIR%\tif-cln.bat
copy NT4\tif-cln.reg %WINDIR%\tif-cln.reg
copy NT4\re-tif.bat %WINDIR%\re-tif.bat

goto reg-inst4

:wip-2kxp

:: check for key file and install 2K-XP version

if not exist 2K\tif-wip.bat goto error
if not exist XP\tif-wip.bat goto error

cls

echo    -------------------
echo    Windows 2000 or XP?
echo    -------------------
echo.
echo    [1] Install for Windows 2000
echo.
echo    [2] Install for Windows XP
echo.
echo    [3] Return to Main Menu
echo.
echo    [4] Exit
echo.
echo    Which do you wish to do?
echo.

choice /c:12345 /n /t:5,90 Please Choose One...

if errorlevel 5 goto wip-2kxp
if errorlevel 4 goto end
if errorlevel 3 goto menu
if errorlevel 2 goto wip-xp
if errorlevel 1 goto wip-2000

:wip-2000

copy 2K\tif-wip.bat %WINDIR%\tif-cln.bat
copy 2K\tif-cln.reg %WINDIR%\tif-cln.reg
copy 2K\re-tif.bat %WINDIR%\re-tif.bat

goto reg-inst4

:wip-xp

copy XP\tif-wip.bat %WINDIR%\tif-cln.bat
copy XP\tif-cln.reg %WINDIR%\tif-cln.reg
copy XP\re-tif.bat %WINDIR%\re-tif.bat

goto reg-inst3

:wip-9xme

:: check for key file and install 9X-ME version

if not exist 9X\tif-wip.bat goto error

copy 9X\tif-wip.bat %WINDIR%\tif-cln.bat
copy 9X\tif-cln.reg %WINDIR%\tif-cln.reg
copy 9X\re-tif.bat %WINDIR%\re-tif.bat

goto reg-inst3

:reg-inst3

:: install prelim Registry entries for 9X

start /w regedit.exe /s 9X\re-tif.reg
start /w regedit.exe /s 9X\tif-cln.reg

if exist %WINDIR%\command\wipe.exe goto success
if exist %WINDIR%\wipe.exe goto success

copy wipe.exe %WINDIR%

goto success

:reg-inst4

:: install prelim Registry entries for NT

start /w regedit.exe /s NT4\re-tif.reg
start /w regedit.exe /s NT4\tif-cln.reg

if exist %WINDIR%\command\wipe.exe goto success
if exist %WINDIR%\wipe.exe goto success

copy wipe.exe %WINDIR%

goto success

::********************************************************************
:uninst
::********************************************************************

cls

:: ** Uninstall TIF-Clean"

if exist %WINDIR%\tif-cln.bat goto go-uninst

goto error2

:go-uninst

del %WINDIR%\tif-cln.bat
del %WINDIR%\tif-cln.reg
del %WINDIR%\re-tif.bat

echo.
echo    TIF-Clean files have been removed from your Windows directory.
echo.
echo    Now, you must remove the Registry entries which start TIF-Clean
echo    during bootup. Removal of the "TIF-Clean" Registry entries can be
echo    done in REGEDIT.EXE (the Windows Registry Editor), which we
echo    will open for you.
echo.
echo    Once REGEDIT.EXE opens, please navigate to the following location
echo    in the Registry, click on the "RE-TIF" value in the right hand 
echo    window pane of REGEDIT.EXE, and select "Edit," then "Delete" from
echo    the menu.
echo.
echo       HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Run
echo.
echo    Next, navigate to this next key (which should be just below the Run key
echo    that you just edited), click on the "TIF-Clean" value in the right hand 
echo    window pane, select "Edit," then "Delete" from the menu.
echo.
echo       HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\RunOnce
echo.
pause

start /w regedit.exe   

goto removed

::********************************************************************
:error
::********************************************************************

cls
echo.
echo    Sorry, one of the required files is missing.
echo    Please correct the error and try again.
echo.
pause
goto menu

::********************************************************************
:error2
::********************************************************************

cls

echo.
echo    Sorry, but it doesn't appear that TIF-Clean is 
echo    currently installed on this computer.
echo.
pause
goto menu

::********************************************************************
:success
::********************************************************************

cls

echo.
echo    TIF-Clean has been installed on this computer.
echo.
echo    TIF-Clean will run the next time you start Windows.
echo.

pause

goto menu

::********************************************************************
:removed
::********************************************************************

cls

echo.
echo    TIF-Clean has been removed from this computer.
echo.
echo    WIPE.EXE and/or DELTREE.EXE have been left in
echo    in your Windows directory for future use.   
echo.

pause

goto menu

::********************************************************************
:end
::********************************************************************

cls

echo.
echo.
echo    Bye for now...
echo.
echo.
echo.
